// Vertex shader for spherical harmonics lighting with disc source

uniform mat4 mvpMatrix;
attribute vec4 vPosition;

varying vec3  diffuseColor;

const float C0 = 1.57079;
const float C1 = 1.57080;
const float C2 = 0.490874;

void main(void)
{
   vec3 baseColor = vec3 (  1.0, 1.0, 1.0 );
   vec3 N = vPosition.xyz;   //normal
   N = normalize ( N );
   float z = N.z;
   float alpha = radians ( 20 );   // angle is 20 degrees 
   float cs = cos ( alpha );
   float sn = sin ( alpha );
   float intensity = C0*(1.0-cs) + C1*sn*sn*z + C2*cs*(1.0-cs*cs)*(3.0*z*z-1.0);
   diffuseColor = baseColor * intensity;

   gl_Position = mvpMatrix * vPosition;
}
