#ifndef _SPHEREIBL_H
#define _SPHEREIBL_H
#include "Shader.h"
#include <vector>

using namespace std;
class XYZ0{
public:
  float x, y, z;
};
class Sphereibl : public Shader 
{
  private:
   static const string vsCode;   // Source code of vertex shader
   static const string fsCode ;  // Source code of fragment shader
   static const int vertexCount = 3;
   static const int COORDS_PER_VERTEX = 3;
   static const int N_STACKS = 24;   
   static const int N_SLICES = 32;
   static const float shininess = 50;    
   static const float lightPos[4];	//light source position
   static const float materialColor[4];
   static const float baseColor[3];
   static const float cubeVertices[72];
   static const int iWidth = 64;
   static const int iHeight = 64;
   GLubyte *makeTexImage( char *loadfile );

   vector<XYZ0> vertices; 
   vector<XYZ0> texPoints;
   // Set color with red, green, blue and alpha (opacity) values
   float *sphereCoords;
   float *texCoords;
   short *drawOrders;            //draw order list
   int nTriangles;
   unsigned texName;
   int objType;                   //Object type
   int texImageWidth;
   int texImageHeight;
  public:
   static const float eyePos[4];  // = {0, 0, 6.3, 1};	viewing position
   Sphereibl( int &success );
   ~Sphereibl();
   void createSphere ( float r, int nSlices, int nStacks ); 
   void init2DTexture();
   void draw( float mvpMatrix[4][4] );
   void setObjectType ();
   void setTime ( float t );
};
#endif

